"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.readonlyWeakMap = exports.readonlyMap = exports.readonlyWeakSet = exports.readonlySet = exports.readonlyNow = exports.validReadonlyDate = exports.readonlyDate = exports.readonlyURL = exports.readonlyURLSearchParams = void 0;
const readonlyURLSearchParams = (init) => new URLSearchParams(
// eslint-disable-next-line @typescript-eslint/consistent-type-assertions, functional/prefer-readonly-type
init);
exports.readonlyURLSearchParams = readonlyURLSearchParams;
const readonlyURL = (url, base) => {
    // eslint-disable-next-line functional/no-try-statements
    try {
        // eslint-disable-next-line @typescript-eslint/consistent-type-assertions
        return new URL(url, base);
    }
    catch {
        return undefined;
    }
};
exports.readonlyURL = readonlyURL;
const readonlyDate = (value
// eslint-disable-next-line @typescript-eslint/consistent-type-assertions
) => new Date(value);
exports.readonlyDate = readonlyDate;
const validReadonlyDate = (value) => {
    // eslint-disable-next-line @typescript-eslint/consistent-type-assertions
    const d = new Date(value);
    return isNaN(d.getMilliseconds()) ? undefined : d;
};
exports.validReadonlyDate = validReadonlyDate;
// eslint-disable-next-line functional/functional-parameters
const readonlyNow = () => Date.now();
exports.readonlyNow = readonlyNow;
const readonlySet = (values) => new Set(values);
exports.readonlySet = readonlySet;
const readonlyWeakSet = (values) => new WeakSet(values);
exports.readonlyWeakSet = readonlyWeakSet;
const readonlyMap = (values) => new Map(values);
exports.readonlyMap = readonlyMap;
const readonlyWeakMap = (values) => new WeakMap(values);
exports.readonlyWeakMap = readonlyWeakMap;
