"use strict";
/* eslint-disable functional/no-return-void */
/* eslint-disable sonarjs/no-duplicate-string */
/* eslint-disable jest/no-conditional-expect */
/* eslint-disable @typescript-eslint/no-unsafe-call */
/* eslint-disable functional/no-conditional-statements */
/* eslint-disable functional/no-loop-statements */
/* eslint-disable functional/functional-parameters */
/* eslint-disable functional/no-expression-statements */
Object.defineProperty(exports, "__esModule", { value: true });
const _1 = require(".");
describe("ReadonlyURL", () => {
    it("iterates through URL search params using for..of", () => {
        const url = (0, _1.readonlyURL)("http://example.com?foo=a&bar=b");
        if (url === undefined) {
            // eslint-disable-next-line functional/no-throw-statements
            throw new Error("url was undefined");
        }
        // eslint-disable-next-line functional/prefer-immutable-types
        for (const p of url.searchParams) {
            // eslint-disable-next-line functional/prefer-immutable-types
            const [k, v] = p;
            if (k === "foo") {
                expect(v).toEqual("a");
            }
            else {
                expect(k).toEqual("bar");
                expect(v).toEqual("b");
            }
        }
    });
    it("doesn't throw on invalid input", () => {
        const url = (0, _1.readonlyURL)("asdf");
        expect(url).toBeUndefined();
    });
    it("doesn't allow mutation via search params", () => {
        const url = (0, _1.readonlyURL)("http://example.com");
        expect(url).toBeDefined();
        if (url === undefined) {
            // eslint-disable-next-line functional/no-throw-statements
            throw new Error("url was undefined");
        }
        // eslint-disable-next-line @typescript-eslint/ban-ts-comment
        // @ts-expect-error
        url.searchParams.append("", "");
    });
});
describe("ReadonlyURLSearchParams", () => {
    it("doesn't throw", () => {
        const x = (0, _1.readonlyURLSearchParams)("");
        expect(x).toBeDefined();
    });
});
describe("ReadonlyDate", () => {
    it("doesn't throw on invalid input", () => {
        const date = (0, _1.readonlyDate)("asdf");
        expect(date.getMilliseconds()).toBeNaN();
    });
    it("doesn't throw when getting current date (now)", () => {
        const date = (0, _1.readonlyDate)((0, _1.readonlyNow)());
        expect(date.getMilliseconds()).toBeGreaterThan(0);
    });
});
describe("ValidReadonlyDate", () => {
    it("returns undefined on invalid input", () => {
        const date = (0, _1.validReadonlyDate)("asdf");
        expect(date).toBeUndefined();
    });
    it("returns a date for valid input", () => {
        // eslint-disable-next-line no-restricted-globals
        const date = (0, _1.validReadonlyDate)(Date.now());
        expect(date).toBeDefined();
    });
});
describe("ReadonlyMap", () => {
    it("allows iteration using for..of", () => {
        const map = (0, _1.readonlyMap)([
            [1, "one"],
            [2, "two"],
            [3, "three"],
        ]);
        // eslint-disable-next-line functional/prefer-immutable-types
        for (const [k, v] of map) {
            expect(k).toBeTruthy();
            expect(v).toBeTruthy();
        }
    });
});
describe("ReadonlyWeakMap", () => {
    it("doesn't throw", () => {
        const map = (0, _1.readonlyWeakMap)([
            [{}, "one"],
            [{}, "two"],
            [{}, "three"],
        ]);
        expect(map).toBeDefined();
    });
});
describe("ReadonlySet", () => {
    it("allows iteration using for..of", () => {
        const set = (0, _1.readonlySet)([
            [1, "one"],
            [2, "two"],
            [3, "three"],
        ]);
        // eslint-disable-next-line functional/prefer-immutable-types
        for (const [k, v] of set) {
            expect(k).toBeTruthy();
            expect(v).toBeTruthy();
        }
    });
});
describe("ReadonlyWeakSet", () => {
    it("doesn't throw", () => {
        const set = (0, _1.readonlyWeakSet)([
            [{}, "one"],
            [{}, "two"],
            [{}, "three"],
        ]);
        expect(set).toBeDefined();
    });
});
